//#include "config.h"
#include <X11/Xlib.h>
#include <X11/extensions/XShm.h>
#include <X11/Xutil.h>
#include <X11/extensions/shape.h>
#include <X11/Xatom.h>
#include <X11/Xos.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include <X11/Xatom.h>
#include <X11/cursorfont.h>
#include <X11/Xmu/WinUtil.h>
#include <glib-2.0/glib.h>
#include   <stdint.h>

// g++ -o ./iconrun1 ./iconrun1.c  -lImlib2 -lX11 -lXmu `pkg-config --cflags --libs glib-2.0`

/*
#include <sys/time.h>
#include "common.h"
#include "image.h"
#include "rend.h"
#include "rgba.h"
#include "ximage.h"
#include "color.h"
 */
#include "Imlib2.h"

Display            *disp;
Window              win;
Window              win2;
Window              win3;
Visual             *vis;
Colormap            cm;
int                 depth;
XSetWindowAttributes attr;
char *appToRun;
int i3;
int mytoggle = 0;
Imlib_Image         buffer3;
Imlib_Font          font3;
int win_pid_list[500];
int act_win_pid=0;
int max_win_id=0;
int show_windows=0;
int win_count=0;
int clock_move=0;
char Alarm1[3][1024];
char say_text[3][1024];
int open_close[3];


#define _NET_WM_STATE_REMOVE        0    /* remove/unset property */
#define _NET_WM_STATE_ADD           1    /* add/set property */
#define _NET_WM_STATE_TOGGLE        2    /* toggle property  */
#define VERSION "1.0.7.1"   //lijianjun append 2012.04.07

#define MWM_HINTS_FUNCTIONS     (1L << 0) /* wheter the functions member of the struct schould be listened to */
#define MWM_HINTS_DECORATIONS   (1L << 1) /* same for decorations member */

#define MWM_FUNC_ALL            (1L << 0) /* means as much as we schould reversely interpret all other bits */
#define MWM_FUNC_RESIZE         (1L << 1) /* self explanatory */
#define MWM_FUNC_MOVE           (1L << 2)
#define MWM_FUNC_MINIMIZE       (1L << 3)
#define MWM_FUNC_MAXIMIZE       (1L << 4)
#define MWM_FUNC_CLOSE          (1L << 5)

#define MWM_DECOR_ALL           (1L << 0) /* equivalent of MWM_HINTS_FUNCTIONS */
#define MWM_DECOR_BORDER        (1L << 1) /* show border */
#define MWM_DECOR_RESIZEH       (1L << 2) /* show resize handle */
#define MWM_DECOR_TITLE         (1L << 3) /* show title bar */
#define MWM_DECOR_MENU          (1L << 4) /* wich buttons to show */
#define MWM_DECOR_MINIMIZE      (1L << 5)
#define MWM_DECOR_MAXIMIZE      (1L << 6)
#define PROP_MWM_HINTS_ELEMENTS 5
typedef struct _mwmhints {
                uint32_t flags;
                uint32_t functions;
                uint32_t decorations;
                int32_t  input_mode;
                uint32_t status;
        } MWMHints;


/* help {{{ */
#define HELP "wmctrl " VERSION "\n" \
"Usage: wmctrl [OPTION]...\n" \
"Actions:\n" \
"  -m                   Show information about the window manager and\n" \
"                       about the environment.\n" \
"  -l                   List windows managed by the window manager.\n" \
"  -d                   List desktops. The current desktop is marked\n" \
"                       with an asterisk.\n" \
"  -s <DESK>            Switch to the specified desktop.\n" \
"  -a <WIN>             Activate the window by switching to its desktop and\n" \
"                       raising it.\n" \
"  -c <WIN>             Close the window gracefully.\n" \
"  -R <WIN>             Move the window to the current desktop and\n" \
"                       activate it.\n" \
"  -r <WIN> -t <DESK>   Move the window to the specified desktop.\n" \
"  -r <WIN> -e <MVARG>  Resize and move the window around the desktop.\n" \
"                       The format of the <MVARG> argument is described below.\n" \
"  -r <WIN> -b <STARG>  Change the state of the window. Using this option it's\n" \
"                       possible for example to make the window maximized,\n" \
"                       minimized or fullscreen. The format of the <STARG>\n" \
"                       argument and list of possible states is given below.\n" \
"  -r <WIN> -N <STR>    Set the name (long title) of the window.\n" \
"  -r <WIN> -I <STR>    Set the icon name (short title) of the window.\n" \
"  -r <WIN> -T <STR>    Set both the name and the icon name of the window.\n" \
"  -k (on|off)          Activate or deactivate window manager's\n" \
"                       \"showing the desktop\" mode. Many window managers\n" \
"                       do not implement this mode.\n" \
"  -o <X>,<Y>           Change the viewport for the current desktop.\n" \
"                       The X and Y values are separated with a comma.\n" \
"                       They define the top left corner of the viewport.\n" \
"                       The window manager may ignore the request.\n" \
"  -n <NUM>             Change number of desktops.\n" \
"                       The window manager may ignore the request.\n" \
"  -g <W>,<H>           Change geometry (common size) of all desktops.\n" \
"                       The window manager may ignore the request.\n" \
"  -h                   Print help.\n" \
"\n" \
"Options:\n" \
"  -i                   Interpret <WIN> as a numerical window ID.\n" \
"  -p                   Include PIDs in the window list. Very few\n" \
"                       X applications support this feature.\n" \
"  -G                   Include geometry in the window list.\n" \
"  -x                   Include WM_CLASS in the window list or\n" \
"                       interpret <WIN> as the WM_CLASS name.\n" \
"  -u                   Override auto-detection and force UTF-8 mode.\n" \
"  -F                   Modifies the behavior of the window title matching\n" \
"                       algorithm. It will match only the full window title\n" \
"                       instead of a substring, when this option is used.\n" \
"                       Furthermore it makes the matching case sensitive.\n" \
"  -v                   Be verbose. Useful for debugging.\n" \
"  -w <WA>              Use a workaround. The option may appear multiple\n" \
"                       times. List of available workarounds is given below.\n" \
"\n" \
"Arguments:\n" \
"  <WIN>                This argument specifies the window. By default it's\n" \
"                       interpreted as a string. The string is matched\n" \
"                       against the window titles and the first matching\n" \
"                       window is used. The matching isn't case sensitive\n" \
"                       and the string may appear in any position\n" \
"                       of the title.\n" \
"\n" \
"                       The -i option may be used to interpret the argument\n" \
"                       as a numerical window ID represented as a decimal\n" \
"                       number. If it starts with \"0x\", then\n" \
"                       it will be interpreted as a hexadecimal number.\n" \
"\n" \
"                       The -x option may be used to interpret the argument\n" \
"                       as a string, which is matched against the window's\n" \
"                       class name (WM_CLASS property). Th first matching\n" \
"                       window is used. The matching isn't case sensitive\n" \
"                       and the string may appear in any position\n" \
"                       of the class name. So it's recommended to  always use\n" \
"                       the -F option in conjunction with the -x option.\n" \
"\n" \
"                       The special string \":SELECT:\" (without the quotes)\n" \
"                       may be used to instruct wmctrl to let you select the\n" \
"                       window by clicking on it.\n" \
"\n" \
"                       The special string \":ACTIVE:\" (without the quotes)\n" \
"                       may be used to instruct wmctrl to use the currently\n" \
"                       active window for the action.\n" \
"\n" \
"  <DESK>               A desktop number. Desktops are counted from zero.\n" \
"\n" \
"  <MVARG>              Specifies a change to the position and size\n" \
"                       of the window. The format of the argument is:\n" \
"\n" \
"                       <G>,<X>,<Y>,<W>,<H>\n" \
"\n" \
"                       <G>: Gravity specified as a number. The numbers are\n" \
"                          defined in the EWMH specification. The value of\n" \
"                          zero is particularly useful, it means \"use the\n" \
"                          default gravity of the window\".\n" \
"                       <X>,<Y>: Coordinates of new position of the window.\n" \
"                       <W>,<H>: New width and height of the window.\n" \
"\n" \
"                       The value of -1 may appear in place of\n" \
"                       any of the <X>, <Y>, <W> and <H> properties\n" \
"                       to left the property unchanged.\n" \
"\n" \
"  <STARG>              Specifies a change to the state of the window\n" \
"                       by the means of _NET_WM_STATE request.\n" \
"                       This option allows two properties to be changed\n" \
"                       simultaneously, specifically to allow both\n" \
"                       horizontal and vertical maximization to be\n" \
"                       altered together.\n" \
"\n" \
"                       The format of the argument is:\n" \
"\n" \
"                       (remove|add|toggle),<PROP1>[,<PROP2>]\n" \
"\n" \
"                       The EWMH specification defines the\n" \
"                       following properties:\n" \
"\n" \
"                           modal, sticky, maximized_vert, maximized_horz,\n" \
"                           shaded, skip_taskbar, skip_pager, hidden,\n" \
"                           fullscreen, above, below\n" \
"\n" \
"Workarounds:\n" \
"\n" \
"  DESKTOP_TITLES_INVALID_UTF8      Print non-ASCII desktop titles correctly\n" \
"                                   when using Window Maker.\n" \
"\n" \
"The format of the window list:\n" \
"\n" \
"  <window ID> <desktop ID> <client machine> <window title>\n" \
"\n" \
"The format of the desktop list:\n" \
"\n" \
"  <desktop ID> [-*] <geometry> <viewport> <workarea> <title>\n" \
"\n" \
"\n" \
"Author, current maintainer: Tomas Styblo <tripie@cpan.org>\n" \
"Released under the GNU General Public License.\n" \
"Copyright (C) 2003\n"
/* }}} */

#define MAX_PROPERTY_VALUE_LEN 4096
#define SELECT_WINDOW_MAGIC ":SELECT:"
#define ACTIVE_WINDOW_MAGIC ":ACTIVE:"

#define p_verbose(...) if (options.verbose) { \
    fprintf(stderr, __VA_ARGS__); \
}

/* declarations of static functions *//*{{{*/
static gboolean wm_supports (Display *disp, const gchar *prop);
static Window *get_client_list (Display *disp, unsigned long *size);
static int client_msg(Display *disp, Window win, char *msg, 
        unsigned long data0, unsigned long data1, 
        unsigned long data2, unsigned long data3,
        unsigned long data4);
static int list_windows (Display *disp,char *skip);
static int list_desktops (Display *disp);
static int showing_desktop (Display *disp);
static int change_viewport (Display *disp);
static int change_geometry (Display *disp);
static int change_number_of_desktops (Display *disp);
static int switch_desktop (Display *disp);
static int wm_info (Display *disp);
static gchar *get_output_str (gchar *str, gboolean is_utf8);
static int action_window (Display *disp, Window win, char mode);
static int action_window_pid (Display *disp, char mode);
static int action_window_str (Display *disp, char mode);
static int activate_window (Display *disp, Window win, 
        gboolean switch_desktop);
static int close_window (Display *disp, Window win);
static int longest_str (gchar **strv);
static int window_to_desktop (Display *disp, Window win, int desktop);
static void window_set_title (Display *disp, Window win, char *str, char mode);
static gchar *get_window_title (Display *disp, Window win);
static gchar *get_window_class (Display *disp, Window win);
static gchar *get_property (Display *disp, Window win, 
        Atom xa_prop_type, gchar *prop_name, unsigned long *size);
static void init_charset(void);
static int window_move_resize (Display *disp, Window win, char *arg);
static int window_state (Display *disp, Window win, char *arg);
static Window Select_Window(Display *dpy);
static Window get_active_window(Display *dpy);

/*}}}*/
   
static struct {
    int verbose;
    int force_utf8;
    int show_class;
    int show_pid;
    int show_geometry;
    int match_by_id;
	int match_by_cls;
    int full_window_title_match;
    int wa_desktop_titles_invalid_utf8;
    char *param_window;
    char *param;
} options;

static gboolean envir_utf8;

int wmctrl (int argc, char argv[5][1024]) { /* {{{ */
    int opt;
    int action = 0;
    int ret = EXIT_SUCCESS;
    int missing_option = 1;
    Display *disp;

//    memset(&options, 0, sizeof(options)); /* just for sure */
    
    /* necessary to make g_get_charset() and g_locale_*() work */
//    setlocale(LC_ALL, "");
    
    /* make "--help" and "--version" work. I don't want to use
     * getopt_long for portability reasons */
    if (argc == 2 && argv[0]) {
        if (strcmp(argv[0], "--help") == 0) {
            fputs(HELP, stdout);
            return EXIT_SUCCESS;
        }
        else if (strcmp(argv[0], "--version") == 0) {
            puts(VERSION);
            return EXIT_SUCCESS;
        }
    }
   
    while ((opt = getopt(argc, (char**)argv, "FGVvhlupidmxa:r:s:c:t:w:k:o:n:g:e:b:N:I:T:R:")) != -1) {
        missing_option = 0;
        switch (opt) {
            case 'F':
                options.full_window_title_match = 1;
                break;
            case 'G':
                options.show_geometry = 1;
                break;
            case 'i':
                options.match_by_id = 1;
                break;
            case 'v':
                options.verbose = 1;
                break;
            case 'u':
                options.force_utf8 = 1;
                break;
			case 'x':
				options.match_by_cls = 1;
				options.show_class = 1;
				break;
            case 'p':
                options.show_pid = 1;
                break;
            case 'a': case 'c': case 'R':
                options.param_window = optarg;
                action = opt;
                break;
            case 'r':
                options.param_window = optarg;
                break; 
            case 't': case 'e': case 'b': case 'N': case 'I': case 'T':
                options.param = optarg;
                action = opt;
                break;
            case 's':
                options.param = optarg;
                action = opt;
                break;
            case 'w':
                if (strcmp(optarg, "DESKTOP_TITLES_INVALID_UTF8") == 0) {
                    options.wa_desktop_titles_invalid_utf8 = 1;
                }
                else {
                    fprintf(stderr, "Unknown workaround: %s\n", optarg);
                    return EXIT_FAILURE;
                }
                break;
            case 'k': case 'o': case 'n': case 'g':
                options.param = optarg;
                action = opt;
                break;
            case '?':
                return EXIT_FAILURE;
            default:
                action = opt;
        }
    }
   
    if (missing_option) {
        fputs(HELP, stderr);
        return EXIT_FAILURE;
    }
   
    init_charset();
    
    if (! (disp = XOpenDisplay(NULL))) {
        fputs("Cannot open display.\n", stderr);
        return EXIT_FAILURE;
    }
   
    switch (action) {
        case 'V':
            puts(VERSION);
            break;
        case 'h':
            fputs(HELP, stdout);
            break;
        case 'l':
            ret = list_windows(disp,(char *)" ");
            break;
        case 'd':
            ret = list_desktops(disp);
            break;
        case 's':
            ret = switch_desktop(disp);
            break;
        case 'm':
            ret = wm_info(disp);
            break;
        case 'a': case 'c': case 'R': 
        case 't': case 'e': case 'b': case 'N': case 'I': case 'T':
            if (! options.param_window) {
                fputs("No window was specified.\n", stderr);
                return EXIT_FAILURE;
            }
            if (options.match_by_id) {
                ret = action_window_pid(disp, action);
            }
            else {
                ret = action_window_str(disp, action);
            }
            break;
        case 'k':
            ret = showing_desktop(disp);
            break;
        case 'o':
            ret = change_viewport(disp);
            break;
        case 'n':
            ret = change_number_of_desktops(disp);
            break;
        case 'g':
            ret = change_geometry(disp);
            break;
    }
    
    XCloseDisplay(disp);
    return ret;
}
/* }}} */

static void init_charset (void) {/*{{{*/
    const gchar *charset; /* unused */
    gchar *lang = getenv("LANG") ? g_ascii_strup(getenv("LANG"), -1) : NULL; 
    gchar *lc_ctype = getenv("LC_CTYPE") ? g_ascii_strup(getenv("LC_CTYPE"), -1) : NULL;
    
    /* this glib function doesn't work on my system ... */
    envir_utf8 = g_get_charset(&charset);

    /* ... therefore we will examine the environment variables */
    if (lc_ctype && (strstr(lc_ctype, "UTF8") || strstr(lc_ctype, "UTF-8"))) {
        envir_utf8 = TRUE;
    }
    else if (lang && (strstr(lang, "UTF8") || strstr(lang, "UTF-8"))) {
        envir_utf8 = TRUE;
    }

    g_free(lang);
    g_free(lc_ctype);
    
    if (options.force_utf8) {
        envir_utf8 = TRUE;
    }
    p_verbose("envir_utf8: %d\n", envir_utf8);
}/*}}}*/

static int client_msg(Display *disp, Window win, char *msg, /* {{{ */
        unsigned long data0, unsigned long data1, 
        unsigned long data2, unsigned long data3,
        unsigned long data4) {
    XEvent event;
    long mask = SubstructureRedirectMask | SubstructureNotifyMask;

    event.xclient.type = ClientMessage;
    event.xclient.serial = 0;
    event.xclient.send_event = True;
    event.xclient.message_type = XInternAtom(disp, msg, False);
    event.xclient.window = win;
    event.xclient.format = 32;
    event.xclient.data.l[0] = data0;
    event.xclient.data.l[1] = data1;
    event.xclient.data.l[2] = data2;
    event.xclient.data.l[3] = data3;
    event.xclient.data.l[4] = data4;
    
    if (XSendEvent(disp, DefaultRootWindow(disp), False, mask, &event)) {
        return EXIT_SUCCESS;
    }
    else {
        fprintf(stderr, "Cannot send %s event.\n", msg);
        return EXIT_FAILURE;
    }
}/*}}}*/

static gchar *get_output_str (gchar *str, gboolean is_utf8) {/*{{{*/
    gchar *out;
   
    if (str == NULL) {
        return NULL;
    }
    
    if (envir_utf8) {
        if (is_utf8) {
            out = g_strdup(str);
        }
        else {
            if (! (out = g_locale_to_utf8(str, -1, NULL, NULL, NULL))) {
                p_verbose("Cannot convert string from locale charset to UTF-8.\n");
                out = g_strdup(str);
            }
        }
    }
    else {
        if (is_utf8) {
            if (! (out = g_locale_from_utf8(str, -1, NULL, NULL, NULL))) {
                p_verbose("Cannot convert string from UTF-8 to locale charset.\n");
                out = g_strdup(str);
            }
        }
        else {
            out = g_strdup(str);
        }
    }

    return out;
}/*}}}*/

static int wm_info (Display *disp) {/*{{{*/
    Window *sup_window = NULL;
    gchar *wm_name = NULL;
    gchar *wm_class = NULL;
    unsigned long *wm_pid = NULL;
    unsigned long *showing_desktop = NULL;
    gboolean name_is_utf8 = TRUE;
    gchar *name_out;
    gchar *class_out;
    
    if (! (sup_window = (Window *)get_property(disp, DefaultRootWindow(disp),
                    XA_WINDOW, "_NET_SUPPORTING_WM_CHECK", NULL))) {
        if (! (sup_window = (Window *)get_property(disp, DefaultRootWindow(disp),
                        XA_CARDINAL, "_WIN_SUPPORTING_WM_CHECK", NULL))) {
            fputs("Cannot get window manager info properties.\n"
                  "(_NET_SUPPORTING_WM_CHECK or _WIN_SUPPORTING_WM_CHECK)\n", stderr);
            return EXIT_FAILURE;
        }
    }

    /* WM_NAME */
    if (! (wm_name = get_property(disp, *sup_window,
            XInternAtom(disp, "UTF8_STRING", False), "_NET_WM_NAME", NULL))) {
        name_is_utf8 = FALSE;
        if (! (wm_name = get_property(disp, *sup_window,
                XA_STRING, "_NET_WM_NAME", NULL))) {
            p_verbose("Cannot get name of the window manager (_NET_WM_NAME).\n");
        }
    }
    name_out = get_output_str(wm_name, name_is_utf8);
  
    /* WM_CLASS */
    if (! (wm_class = get_property(disp, *sup_window,
            XInternAtom(disp, "UTF8_STRING", False), "WM_CLASS", NULL))) {
        name_is_utf8 = FALSE;
        if (! (wm_class = get_property(disp, *sup_window,
                XA_STRING, "WM_CLASS", NULL))) {
            p_verbose("Cannot get class of the window manager (WM_CLASS).\n");
        }
    }
    class_out = get_output_str(wm_class, name_is_utf8);
  

    /* WM_PID */
    if (! (wm_pid = (unsigned long *)get_property(disp, *sup_window,
                    XA_CARDINAL, "_NET_WM_PID", NULL))) {
        p_verbose("Cannot get pid of the window manager (_NET_WM_PID).\n");
    }
    
    /* _NET_SHOWING_DESKTOP */
    if (! (showing_desktop = (unsigned long *)get_property(disp, DefaultRootWindow(disp),
                    XA_CARDINAL, "_NET_SHOWING_DESKTOP", NULL))) {
        p_verbose("Cannot get the _NET_SHOWING_DESKTOP property.\n");
    }
    
    /* print out the info */
   // printf("Name: %s\n", name_out ? name_out : "N/A");
   // printf("Class: %s\n", class_out ? class_out : "N/A");
    
    if (wm_pid) {
       // printf("PID: %lu\n", *wm_pid);
    }
    else {
       // printf("PID: N/A\n");
    }
    
    if (showing_desktop) {
       // printf("Window manager's \"showing the desktop\" mode: %s\n",
//                *showing_desktop == 1 ? "ON" : "OFF");
    }
    else {
       // printf("Window manager's \"showing the desktop\" mode: N/A\n");
    }
    
    g_free(name_out);
    g_free(sup_window);
    g_free(wm_name);
	g_free(wm_class);
    g_free(wm_pid);
    g_free(showing_desktop);
    
    return EXIT_SUCCESS;
}/*}}}*/

static int showing_desktop (Display *disp) {/*{{{*/
    unsigned long state;
    
    if (strcmp(options.param, "on") == 0) {
        state = 1;
    }
    else if (strcmp(options.param, "off") == 0) {
        state = 0;
    }
    else {
        fputs("The argument to the -k option must be either \"on\" or \"off\"\n", stderr);
        return EXIT_FAILURE;
    }

    return client_msg(disp, DefaultRootWindow(disp), "_NET_SHOWING_DESKTOP", 
        state, 0, 0, 0, 0);
}/*}}}*/

static int change_viewport (Display *disp) {/*{{{*/
    unsigned long x, y;
    const char *argerr = "The -o option expects two integers separated with a comma.\n";
   
    if (sscanf(options.param, "%lu,%lu", &x, &y) == 2) {
        return client_msg(disp, DefaultRootWindow(disp), "_NET_DESKTOP_VIEWPORT", 
            x, y, 0, 0, 0);
    }
    else {
        fputs(argerr, stderr);
        return EXIT_FAILURE;
    }
}/*}}}*/

static int change_geometry (Display *disp) {/*{{{*/
    unsigned long x, y;
    const char *argerr = "The -g option expects two integers separated with a comma.\n";
   
    if (sscanf(options.param, "%lu,%lu", &x, &y) == 2) {
        return client_msg(disp, DefaultRootWindow(disp), "_NET_DESKTOP_GEOMETRY", 
            x, y, 0, 0, 0);
    }
    else {
        fputs(argerr, stderr);
        return EXIT_FAILURE;
    }
}/*}}}*/

static int change_number_of_desktops (Display *disp) {/*{{{*/
    unsigned long n;

    if (sscanf(options.param, "%lu", &n) != 1) {
        fputs("The -n option expects an integer.\n", stderr);
        return EXIT_FAILURE;
    }
    
    return client_msg(disp, DefaultRootWindow(disp), "_NET_NUMBER_OF_DESKTOPS", 
        n, 0, 0, 0, 0);
}/*}}}*/

static int switch_desktop (Display *disp) {/*{{{*/
    int target = -1;
    
    target = atoi(options.param); 
    if (target == -1) {
        fputs("Invalid desktop ID.\n", stderr);
        return EXIT_FAILURE;
    }
    
    return client_msg(disp, DefaultRootWindow(disp), "_NET_CURRENT_DESKTOP", 
            (unsigned long)target, 0, 0, 0, 0);
}/*}}}*/

static void window_set_title (Display *disp, Window win, /* {{{ */
        char *title, char mode) {
    gchar *title_utf8;
    gchar *title_local;

    if (envir_utf8) {
        title_utf8 = (gchar*)g_strdup(title);
        title_local = NULL;
    }
    else {
        if (! (title_utf8 = (gchar*)g_locale_to_utf8(title, -1, NULL, NULL, NULL))) {
            title_utf8 = (gchar*)g_strdup(title);
        }
        title_local = g_strdup(title);
    }
    
    if (mode == 'T' || mode == 'N') {
        /* set name */
        if (title_local) {
            XChangeProperty(disp, win, XA_WM_NAME, XA_STRING, 8, PropModeReplace,
                    (const unsigned char*)title_local, strlen(title_local));
        }
        else {
            XDeleteProperty(disp, win, XA_WM_NAME);
        }
        XChangeProperty(disp, win, XInternAtom(disp, "_NET_WM_NAME", False), 
                XInternAtom(disp, "UTF8_STRING", False), 8, PropModeReplace,
                (const unsigned char*)title_utf8, strlen(title_utf8));
    }

    if (mode == 'T' || mode == 'I') {
        /* set icon name */
        if (title_local) {
            XChangeProperty(disp, win, XA_WM_ICON_NAME, XA_STRING, 8, PropModeReplace,
                    (const unsigned char*)title_local, strlen(title_local));
        }
        else {
            XDeleteProperty(disp, win, XA_WM_ICON_NAME);
        }
        XChangeProperty(disp, win, XInternAtom(disp, "_NET_WM_ICON_NAME", False), 
                XInternAtom(disp, "UTF8_STRING", False), 8, PropModeReplace,
                (const unsigned char*)title_utf8, strlen(title_utf8));
    }
    
    g_free(title_utf8);
    g_free(title_local);
    
}/*}}}*/

static int window_to_desktop (Display *disp, Window win, int desktop) {/*{{{*/
    unsigned long *cur_desktop = NULL;
    Window root = DefaultRootWindow(disp);
   
    if (desktop == -1) {
        if (! (cur_desktop = (unsigned long *)get_property(disp, root,
                XA_CARDINAL, "_NET_CURRENT_DESKTOP", NULL))) {
            if (! (cur_desktop = (unsigned long *)get_property(disp, root,
                    XA_CARDINAL, "_WIN_WORKSPACE", NULL))) {
                fputs("Cannot get current desktop properties. "
                      "(_NET_CURRENT_DESKTOP or _WIN_WORKSPACE property)"
                      "\n", stderr);
                return EXIT_FAILURE;
            }
        }
        desktop = *cur_desktop;
    }
    g_free(cur_desktop);

    return client_msg(disp, win, "_NET_WM_DESKTOP", (unsigned long)desktop,
            0, 0, 0, 0);
}/*}}}*/

static int activate_window (Display *disp, Window win, /* {{{ */
        gboolean switch_desktop) {
    unsigned long *desktop;

    /* desktop ID */
    if ((desktop = (unsigned long *)get_property(disp, win,
            XA_CARDINAL, "_NET_WM_DESKTOP", NULL)) == NULL) {
        if ((desktop = (unsigned long *)get_property(disp, win,
                XA_CARDINAL, "_WIN_WORKSPACE", NULL)) == NULL) {
            p_verbose("Cannot find desktop ID of the window.\n");
        }
    }

    if (switch_desktop && desktop) {
        if (client_msg(disp, DefaultRootWindow(disp), 
                    "_NET_CURRENT_DESKTOP", 
                    *desktop, 0, 0, 0, 0) != EXIT_SUCCESS) {
            p_verbose("Cannot switch desktop.\n");
        }
        g_free(desktop);
    }

    client_msg(disp, win, "_NET_ACTIVE_WINDOW", 
            0, 0, 0, 0, 0);
    XMapRaised(disp, win);

    return EXIT_SUCCESS;
}/*}}}*/

static int close_window (Display *disp, Window win) {/*{{{*/
    return client_msg(disp, win, "_NET_CLOSE_WINDOW", 
            0, 0, 0, 0, 0);
}/*}}}*/

static int window_state (Display *disp, Window win, char *arg) {/*{{{*/
    unsigned long action;
    Atom prop1 = 0;
    Atom prop2 = 0;
    char *p1, *p2;
    const char *argerr = "The -b option expects a list of comma separated parameters: \"(remove|add|toggle),<PROP1>[,<PROP2>]\"\n";

    if (!arg || strlen(arg) == 0) {
        fputs(argerr, stderr);
        return EXIT_FAILURE;
    }

    if ((p1 = strchr(arg, ','))) {
        gchar *tmp_prop1, *tmp1;
        
        *p1 = '\0';

        /* action */
        if (strcmp(arg, "remove") == 0) {
            action = _NET_WM_STATE_REMOVE;
        }
        else if (strcmp(arg, "add") == 0) {
            action = _NET_WM_STATE_ADD;
        }
        else if (strcmp(arg, "toggle") == 0) {
            action = _NET_WM_STATE_TOGGLE;
        }
        else {
            fputs("Invalid action. Use either remove, add or toggle.\n", stderr);
            return EXIT_FAILURE;
        }
        p1++;

        /* the second property */
        if ((p2 = strchr(p1, ','))) {
            gchar *tmp_prop2, *tmp2;
            *p2 = '\0';
            p2++;
            if (strlen(p2) == 0) {
                fputs("Invalid zero length property.\n", stderr);
                return EXIT_FAILURE;
            }
            tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
            p_verbose("State 2: %s\n", tmp_prop2); 
            prop2 = XInternAtom(disp, tmp_prop2, False);
            g_free(tmp2);
            g_free(tmp_prop2);
        }

        /* the first property */
        if (strlen(p1) == 0) {
            fputs("Invalid zero length property.\n", stderr);
            return EXIT_FAILURE;
        }
        tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
        p_verbose("State 1: %s\n", tmp_prop1); 
        prop1 = XInternAtom(disp, tmp_prop1, False);
        g_free(tmp1);
        g_free(tmp_prop1);

        
        return client_msg(disp, win, "_NET_WM_STATE", 
            action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
    }
    else {
        fputs(argerr, stderr);
        return EXIT_FAILURE;
    }
}/*}}}*/

static gboolean wm_supports (Display *disp, const gchar *prop) {/*{{{*/
    Atom xa_prop = XInternAtom(disp, prop, False);
    Atom *list;
    unsigned long size;
    int i;

    if (! (list = (Atom *)get_property(disp, DefaultRootWindow(disp),
            XA_ATOM, "_NET_SUPPORTED", &size))) {
        p_verbose("Cannot get _NET_SUPPORTED property.\n");
        return FALSE;
    }

    for (i = 0; i < size / sizeof(Atom); i++) {
        if (list[i] == xa_prop) {
            g_free(list);
            return TRUE;
        }
    }
    
    g_free(list);
    return FALSE;
}/*}}}*/

static int window_move_resize (Display *disp, Window win, char *arg) {/*{{{*/
    signed long grav, x, y, w, h;
    unsigned long grflags;
    const char *argerr = "The -e option expects a list of comma separated integers: \"gravity,X,Y,width,height\"\n";
    
    if (!arg || strlen(arg) == 0) {
        fputs(argerr, stderr);
        return EXIT_FAILURE;
    }

    if (sscanf(arg, "%ld,%ld,%ld,%ld,%ld", &grav, &x, &y, &w, &h) != 5) {
        fputs(argerr, stderr);
        return EXIT_FAILURE;
    }

    if (grav < 0) {
        fputs("Value of gravity mustn't be negative. Use zero to use the default gravity of the window.\n", stderr);
        return EXIT_FAILURE;
    }
    
    grflags = grav;
    if (x != -1) grflags |= (1 << 8);
    if (y != -1) grflags |= (1 << 9);
    if (w != -1) grflags |= (1 << 10);
    if (h != -1) grflags |= (1 << 11);
   
    p_verbose("grflags: %lu\n", grflags);
   
    if (wm_supports(disp, "_NET_MOVERESIZE_WINDOW")){
        return client_msg(disp, win, "_NET_MOVERESIZE_WINDOW", 
            grflags, (unsigned long)x, (unsigned long)y, (unsigned long)w, (unsigned long)h);
    }
    else {
        p_verbose("WM doesn't support _NET_MOVERESIZE_WINDOW. Gravity will be ignored.\n");
        if ((w < 1 || h < 1) && (x >= 0 && y >= 0)) {
            XMoveWindow(disp, win, x, y);
        }
        else if ((x < 0 || y < 0) && (w >= 1 && h >= -1)) {
            XResizeWindow(disp, win, w, h);
        }
        else if (x >= 0 && y >= 0 && w >= 1 && h >= 1) {
            XMoveResizeWindow(disp, win, x, y, w, h);
        }
        return EXIT_SUCCESS;
    }
}/*}}}*/

static int action_window (Display *disp, Window win, char mode) {/*{{{*/
    p_verbose("Using window: 0x%.8lx\n", win);
    switch (mode) {
        case 'a':
            return activate_window(disp, win, TRUE);

        case 'c':
            return close_window(disp, win);

        case 'e':
            /* resize/move the window around the desktop => -r -e */
            return window_move_resize(disp, win, options.param);

        case 'b':
            /* change state of a window => -r -b */
            return window_state(disp, win, options.param);
        
        case 't':
            /* move the window to the specified desktop => -r -t */
            return window_to_desktop(disp, win, atoi(options.param));
        
        case 'R':
            /* move the window to the current desktop and activate it => -r */
            if (window_to_desktop(disp, win, -1) == EXIT_SUCCESS) {
                usleep(100000); /* 100 ms - make sure the WM has enough
                    time to move the window, before we activate it */
                return activate_window(disp, win, FALSE);
            }
            else {
                return EXIT_FAILURE;
            }

        case 'N': case 'I': case 'T':
            window_set_title(disp, win, options.param, mode);
            return EXIT_SUCCESS;

        default:
            fprintf(stderr, "Unknown action: '%c'\n", mode);
            return EXIT_FAILURE;
    }
}/*}}}*/

static int action_window_pid (Display *disp, char mode) {/*{{{*/
    unsigned long wid;

    if (sscanf(options.param_window, "0x%lx", &wid) != 1 &&
            sscanf(options.param_window, "0X%lx", &wid) != 1 &&
            sscanf(options.param_window, "%lu", &wid) != 1) {
        fputs("Cannot convert argument to number.\n", stderr);
        return EXIT_FAILURE;
    }

    return action_window(disp, (Window)wid, mode);
}/*}}}*/

static int action_window_str (Display *disp, char mode) {/*{{{*/
    Window activate = 0;
    Window *client_list;
    unsigned long client_list_size;
    int i;
    
    if (strcmp(SELECT_WINDOW_MAGIC, options.param_window) == 0) {
        activate = Select_Window(disp);
        if (activate) {
            return action_window(disp, activate, mode);
        }
        else {
            return EXIT_FAILURE;
        }
    }
    if (strcmp(ACTIVE_WINDOW_MAGIC, options.param_window) == 0) {
        activate = get_active_window(disp);
        if (activate)
        {
            return action_window(disp, activate, mode);
        }
        else
        {
            return EXIT_FAILURE;
        }
    }
    else {
        if ((client_list = get_client_list(disp, &client_list_size)) == NULL) {
            return EXIT_FAILURE; 
        }
        
        for (i = 0; i < client_list_size / sizeof(Window); i++) {
 			gchar *match_utf8;
 			if (options.show_class) {
 	            match_utf8 = get_window_class(disp, client_list[i]); /* UTF8 */
 			}
 			else {
 				match_utf8 = get_window_title(disp, client_list[i]); /* UTF8 */
 			}
            if (match_utf8) {
                gchar *match;
                gchar *match_cf;
                gchar *match_utf8_cf = NULL;
                if (envir_utf8) {
                    match = g_strdup(options.param_window);
                    match_cf = g_utf8_casefold(options.param_window, -1);
                }
                else {
                    if (! (match = g_locale_to_utf8(options.param_window, -1, NULL, NULL, NULL))) {
                        match = g_strdup(options.param_window);
                    }
                    match_cf = g_utf8_casefold(match, -1);
                }
                
                if (!match || !match_cf) {
                    continue;
                }

                match_utf8_cf = g_utf8_casefold(match_utf8, -1);

                if ((options.full_window_title_match && strcmp(match_utf8, match) == 0) ||
                        (!options.full_window_title_match && strstr(match_utf8_cf, match_cf))) {
                    activate = client_list[i];
                    g_free(match);
                    g_free(match_cf);
                    g_free(match_utf8);
                    g_free(match_utf8_cf);
                    break;
                }
                g_free(match);
                g_free(match_cf);
                g_free(match_utf8);
                g_free(match_utf8_cf);
            }
        }
        g_free(client_list);

        if (activate) {
            return action_window(disp, activate, mode);
        }
        else {
            return EXIT_FAILURE;
        }
    }
}/*}}}*/

static int list_desktops (Display *disp) {/*{{{*/
    unsigned long *num_desktops = NULL;
    unsigned long *cur_desktop = NULL;
    unsigned long desktop_list_size = 0;
    unsigned long *desktop_geometry = NULL;
    unsigned long desktop_geometry_size = 0;
    gchar **desktop_geometry_str = NULL;
    unsigned long *desktop_viewport = NULL;
    unsigned long desktop_viewport_size = 0;
    gchar **desktop_viewport_str = NULL;
    unsigned long *desktop_workarea = NULL;
    unsigned long desktop_workarea_size = 0;
    gchar **desktop_workarea_str = NULL;
    gchar *list = NULL;
    int i;
    int id;
    Window root = DefaultRootWindow(disp);
    int ret = EXIT_FAILURE;
    gchar **names = NULL;
    gboolean names_are_utf8 = TRUE;
    
    if (! (num_desktops = (unsigned long *)get_property(disp, root,
            XA_CARDINAL, "_NET_NUMBER_OF_DESKTOPS", NULL))) {
        if (! (num_desktops = (unsigned long *)get_property(disp, root,
                XA_CARDINAL, "_WIN_WORKSPACE_COUNT", NULL))) {
            fputs("Cannot get number of desktops properties. "
                  "(_NET_NUMBER_OF_DESKTOPS or _WIN_WORKSPACE_COUNT)"
                  "\n", stderr);
            goto cleanup;
        }
    }
    
    if (! (cur_desktop = (unsigned long *)get_property(disp, root,
            XA_CARDINAL, "_NET_CURRENT_DESKTOP", NULL))) {
        if (! (cur_desktop = (unsigned long *)get_property(disp, root,
                XA_CARDINAL, "_WIN_WORKSPACE", NULL))) {
            fputs("Cannot get current desktop properties. "
                  "(_NET_CURRENT_DESKTOP or _WIN_WORKSPACE property)"
                  "\n", stderr);
            goto cleanup;
        }
    }

    if (options.wa_desktop_titles_invalid_utf8 || 
            (list = get_property(disp, root, 
            XInternAtom(disp, "UTF8_STRING", False), 
            "_NET_DESKTOP_NAMES", &desktop_list_size)) == NULL) {
        names_are_utf8 = FALSE;
        if ((list = get_property(disp, root, 
            XA_STRING, 
            "_WIN_WORKSPACE_NAMES", &desktop_list_size)) == NULL) {
            p_verbose("Cannot get desktop names properties. "
                  "(_NET_DESKTOP_NAMES or _WIN_WORKSPACE_NAMES)"
                  "\n");
            /* ignore the error - list the desktops without names */
        }
    }
 
    /* common size of all desktops */
    if (! (desktop_geometry = (unsigned long *)get_property(disp, DefaultRootWindow(disp),
                    XA_CARDINAL, "_NET_DESKTOP_GEOMETRY", &desktop_geometry_size))) {
        p_verbose("Cannot get common size of all desktops (_NET_DESKTOP_GEOMETRY).\n");
    }
     
    /* desktop viewport */
    if (! (desktop_viewport = (unsigned long *)get_property(disp, DefaultRootWindow(disp),
                    XA_CARDINAL, "_NET_DESKTOP_VIEWPORT", &desktop_viewport_size))) {
        p_verbose("Cannot get common size of all desktops (_NET_DESKTOP_VIEWPORT).\n");
    }
     
    /* desktop workarea */
    if (! (desktop_workarea = (unsigned long *)get_property(disp, DefaultRootWindow(disp),
                    XA_CARDINAL, "_NET_WORKAREA", &desktop_workarea_size))) {
        if (! (desktop_workarea = (unsigned long *)get_property(disp, DefaultRootWindow(disp),
                        XA_CARDINAL, "_WIN_WORKAREA", &desktop_workarea_size))) {
            p_verbose("Cannot get _NET_WORKAREA property.\n");
        }
    }

    /* prepare the array of desktop names */
    names = (gchar**)g_malloc0(*num_desktops * sizeof(char *));
    if (list) {
        id = 0;
        names[id++] = list;
        for (i = 0; i < desktop_list_size; i++) {
            if (list[i] == '\0') {
                if (id >= *num_desktops) {
                    break;
                }
                names[id++] = list + i + 1;
            }
        }
    }

    /* prepare desktop geometry strings */
    desktop_geometry_str = (gchar**)g_malloc0((*num_desktops + 1) * sizeof(char *));
    if (desktop_geometry && desktop_geometry_size > 0) {
        if (desktop_geometry_size == 2 * sizeof(*desktop_geometry)) {
            /* only one value - use it for all desktops */
            p_verbose("WM provides _NET_DESKTOP_GEOMETRY value common for all desktops.\n");
            for (i = 0; i < *num_desktops; i++) {
                desktop_geometry_str[i] = g_strdup_printf("%lux%lu", 
                desktop_geometry[0], desktop_geometry[1]);
            }
        }
        else {
            /* seperate values for desktops of different size */
            p_verbose("WM provides separate _NET_DESKTOP_GEOMETRY value for each desktop.\n");
            for (i = 0; i < *num_desktops; i++) {
                if (i < desktop_geometry_size / sizeof(*desktop_geometry) / 2) {
                    desktop_geometry_str[i] = g_strdup_printf("%lux%lu", 
                        desktop_geometry[i*2], desktop_geometry[i*2+1]);
                }
                else {
                    desktop_geometry_str[i] = g_strdup("N/A");
                }
            }
        }
    }
    else {
        for (i = 0; i < *num_desktops; i++) {
            desktop_geometry_str[i] = g_strdup("N/A");
        }
    }
 
    /* prepare desktop viewport strings */
    desktop_viewport_str = (gchar**) g_malloc0((*num_desktops + 1) * sizeof(char *));
    if (desktop_viewport && desktop_viewport_size > 0) {
        if (desktop_viewport_size == 2 * sizeof(*desktop_viewport)) {
            /* only one value - use it for current desktop */
            p_verbose("WM provides _NET_DESKTOP_VIEWPORT value only for the current desktop.\n");
            for (i = 0; i < *num_desktops; i++) {
                if (i == *cur_desktop) {
                    desktop_viewport_str[i] = g_strdup_printf("%lu,%lu", 
                        desktop_viewport[0], desktop_viewport[1]);
                }
                else {
                    desktop_viewport_str[i] = g_strdup("N/A");
                }
            }
        }
        else {
            /* seperate values for each of desktops */
            for (i = 0; i < *num_desktops; i++) {
                if (i < desktop_viewport_size / sizeof(*desktop_viewport) / 2) {
                    desktop_viewport_str[i] = g_strdup_printf("%lu,%lu", 
                        desktop_viewport[i*2], desktop_viewport[i*2+1]);
                }
                else {
                    desktop_viewport_str[i] = g_strdup("N/A");
                }
            }
        }
    }
    else {
        for (i = 0; i < *num_desktops; i++) {
            desktop_viewport_str[i] = g_strdup("N/A");
        }
    }
 
    /* prepare desktop workarea strings */
    desktop_workarea_str = (gchar**)g_malloc0((*num_desktops + 1) * sizeof(char *));
    if (desktop_workarea && desktop_workarea_size > 0) {
        if (desktop_workarea_size == 4 * sizeof(*desktop_workarea)) {
            /* only one value - use it for current desktop */
            p_verbose("WM provides _NET_WORKAREA value only for the current desktop.\n");
            for (i = 0; i < *num_desktops; i++) {
                if (i == *cur_desktop) {
                    desktop_workarea_str[i] = g_strdup_printf("%lu,%lu %lux%lu", 
                        desktop_workarea[0], desktop_workarea[1],
                        desktop_workarea[2], desktop_workarea[3]);
                }
                else {
                    desktop_workarea_str[i] = g_strdup("N/A");
                }
            }
        }
        else {
            /* seperate values for each of desktops */
            for (i = 0; i < *num_desktops; i++) {
                if (i < desktop_workarea_size / sizeof(*desktop_workarea) / 4) {
                    desktop_workarea_str[i] = g_strdup_printf("%lu,%lu %lux%lu", 
                        desktop_workarea[i*4], desktop_workarea[i*4+1],
                        desktop_workarea[i*4+2], desktop_workarea[i*4+3]);
                }
                else {
                    desktop_workarea_str[i] = g_strdup("N/A");
                }
            }
        }
    }
    else {
        for (i = 0; i < *num_desktops; i++) {
            desktop_workarea_str[i] = g_strdup("N/A");
        }
    }
 
    /* print the list */
    for (i = 0; i < *num_desktops; i++) {
        gchar *out = get_output_str(names[i], names_are_utf8);
       // printf("%-2d %c DG: %-*s  VP: %-*s  WA: %-*s  %s\n", i, i == *cur_desktop ? '*' : '-',
//                longest_str(desktop_geometry_str), desktop_geometry_str[i], 
//                longest_str(desktop_viewport_str), desktop_viewport_str[i], 
//                longest_str(desktop_workarea_str), desktop_workarea_str[i], 
//                out ? out : "N/A");
        g_free(out);
    }
    
    p_verbose("Total number of desktops: %lu\n", *num_desktops);
    p_verbose("Current desktop ID (counted from zero): %lu\n", *cur_desktop);
    
    ret = EXIT_SUCCESS;
    goto cleanup;
    
cleanup:
    g_free(names);
    g_free(num_desktops);
    g_free(cur_desktop);
    g_free(desktop_geometry);
    g_strfreev(desktop_geometry_str);
    g_free(desktop_viewport);
    g_strfreev(desktop_viewport_str);
    g_free(desktop_workarea);
    g_strfreev(desktop_workarea_str);
    g_free(list);
    
    return ret;
}/*}}}*/

static int longest_str (gchar **strv) {/*{{{*/
    int max = 0;
    int i = 0;
    
    while (strv && strv[i]) {
        if (strlen(strv[i]) > max) {
            max = strlen(strv[i]);
        }
        i++;
    }

    return max;
}/*}}}*/

static Window *get_client_list (Display *disp, unsigned long *size) {/*{{{*/
    Window *client_list;

    if ((client_list = (Window *)get_property(disp, DefaultRootWindow(disp), 
                    XA_WINDOW, "_NET_CLIENT_LIST", size)) == NULL) {
        if ((client_list = (Window *)get_property(disp, DefaultRootWindow(disp), 
                        XA_CARDINAL, "_WIN_CLIENT_LIST", size)) == NULL) {
            fputs("Cannot get client list properties. \n"
                  "(_NET_CLIENT_LIST or _WIN_CLIENT_LIST)"
                  "\n", stderr);
            return NULL;
        }
    }

    return client_list;
}/*}}}*/

static int list_windows (Display *disp,char *skip) {/*{{{*/
    Window *client_list;
    unsigned long client_list_size;
    int i,n;
    int max_client_machine_len = 0;
    n=0;
    for (i = 0; i < 500; i++)
        win_pid_list[i]=0;
    if ((client_list = get_client_list(disp, &client_list_size)) == NULL) {
        return EXIT_FAILURE; 
    }
    
    /* find the longest client_machine name */
    for (i = 0; i < client_list_size / sizeof(Window); i++) {
        gchar *client_machine;
        if ((client_machine = get_property(disp, client_list[i],
                XA_STRING, "WM_CLIENT_MACHINE", NULL))) {
            max_client_machine_len = strlen(client_machine);    
        }
        g_free(client_machine);
    }
    
    /* print the list */
    for (i = 0; i < client_list_size / sizeof(Window); i++) {
//        gchar *title_utf8 = get_window_title(disp, client_list[i]); /* UTF8 */
//        gchar *title_out = get_output_str(title_utf8, TRUE);
//        gchar *client_machine;
        gchar *class_out = get_window_class(disp, client_list[i]); /* UTF8 */
//        unsigned long *pid;
//        unsigned long *desktop;
//        int x, y, junkx, junky;
//        unsigned int wwidth, wheight, bw, depth;
//        Window junkroot;

        /* desktop ID */
//        if ((desktop = (unsigned long *)get_property(disp, client_list[i],
//                XA_CARDINAL, "_NET_WM_DESKTOP", NULL)) == NULL) {
//            desktop = (unsigned long *)get_property(disp, client_list[i],
//                    XA_CARDINAL, "_WIN_WORKSPACE", NULL);
//        }

        /* client machine */
//        client_machine = get_property(disp, client_list[i],
//                XA_STRING, "WM_CLIENT_MACHINE", NULL);
       
        /* pid */
//        pid = (unsigned long *)get_property(disp, client_list[i],
//                XA_CARDINAL, "_NET_WM_PID", NULL);
	    /* geometry */
//        XGetGeometry (disp, client_list[i], &junkroot, &junkx, &junky,
//                          &wwidth, &wheight, &bw, &depth);
//        XTranslateCoordinates (disp, client_list[i], junkroot, junkx, junky,
//                               &x, &y, &junkroot);
      
        /* special desktop ID -1 means "all desktops", so we 
           have to convert the desktop value to signed long */
       // printf("0x%.8lx %2ld", client_list[i], 
//                desktop ? (signed long)*desktop : 0);
//        if (options.show_pid) {
          // printf(" %-6lu", pid ? *pid : 0);
//        }
//        if (options.show_geometry) {
          // printf(" %-4d %-4d %-4d %-4d", x, y, wwidth, wheight);
//        }
//		if (options.show_class) {
		  // printf(" %-20s ", class_out ? class_out : "N/A");
//		}
//		printf(" %s %s", skip,class_out );
        if (class_out!=NULL)
        if (strstr(skip,class_out)==NULL )
        {
          win_pid_list[n]=(int)client_list[i];
          n=n+1;
        }
       // printf(" %*s %s\n",
//              max_client_machine_len,
//              client_machine ? client_machine : "N/A",
//              title_out ? title_out : "N/A"
//		);
//        g_free(title_utf8);
//        g_free(title_out);
//        g_free(desktop);
//        g_free(client_machine);
        g_free(class_out);
//        g_free(pid);
    }
    g_free(client_list);
    max_win_id=win_pid_list[n-1];
    win_count=n;
    return EXIT_SUCCESS;
}/*}}}*/

static gchar *get_window_class (Display *disp, Window win) {/*{{{*/
    gchar *class_utf8;
    gchar *wm_class;
    unsigned long size;

    wm_class = get_property(disp, win, XA_STRING, "WM_CLASS", &size);
    if (wm_class) {
        gchar *p_0 = strchr(wm_class, '\0');
        if (wm_class + size - 1 > p_0) {
            *(p_0) = '.';
        }
        class_utf8 = g_locale_to_utf8(wm_class, -1, NULL, NULL, NULL);
    }
    else {
        class_utf8 = NULL;
    }

    g_free(wm_class);
    
    return class_utf8;
}/*}}}*/

static gchar *get_window_title (Display *disp, Window win) {/*{{{*/
    gchar *title_utf8;
    gchar *wm_name;
    gchar *net_wm_name;

    wm_name = get_property(disp, win, XA_STRING, "WM_NAME", NULL);
    net_wm_name = get_property(disp, win, 
            XInternAtom(disp, "UTF8_STRING", False), "_NET_WM_NAME", NULL);

    if (net_wm_name) {
        title_utf8 = g_strdup(net_wm_name);
    }
    else {
        if (wm_name) {
            title_utf8 = g_locale_to_utf8(wm_name, -1, NULL, NULL, NULL);
        }
        else {
            title_utf8 = NULL;
        }
    }

    g_free(wm_name);
    g_free(net_wm_name);
    
    return title_utf8;
}/*}}}*/

static gchar *get_property (Display *disp, Window win, /*{{{*/
        Atom xa_prop_type, gchar *prop_name, unsigned long *size) {
    Atom xa_prop_name;
    Atom xa_ret_type;
    int ret_format;
    unsigned long ret_nitems;
    unsigned long ret_bytes_after;
    unsigned long tmp_size;
    unsigned char *ret_prop;
    gchar *ret;
    
    xa_prop_name = XInternAtom(disp, prop_name, False);
    
    /* MAX_PROPERTY_VALUE_LEN / 4 explanation (XGetWindowProperty manpage):
     *
     * long_length = Specifies the length in 32-bit multiples of the
     *               data to be retrieved.
     */
    if (XGetWindowProperty(disp, win, xa_prop_name, 0, MAX_PROPERTY_VALUE_LEN / 4, False,
            xa_prop_type, &xa_ret_type, &ret_format,     
            &ret_nitems, &ret_bytes_after, &ret_prop) != Success) {
        p_verbose("Cannot get %s property.\n", prop_name);
        return NULL;
    }
  
    if (xa_ret_type != xa_prop_type) {
        p_verbose("Invalid type of %s property.\n", prop_name);
        XFree(ret_prop);
        return NULL;
    }

    /* null terminate the result to make string handling easier */
    tmp_size = (ret_format / 8) * ret_nitems;
    ret = (gchar*)g_malloc(tmp_size + 1);
    memcpy(ret, ret_prop, tmp_size);
    ret[tmp_size] = '\0';

    if (size) {
        *size = tmp_size;
    }
    
    XFree(ret_prop);
    return ret;
}/*}}}*/

static Window Select_Window(Display *dpy) {/*{{{*/
    /*
     * Routine to let user select a window using the mouse
     * Taken from xfree86.
     */

    int status;
    Cursor cursor;
    XEvent event;
    Window target_win = None, root = DefaultRootWindow(dpy);
    int buttons = 0;
    int dummyi;
    unsigned int dummy;

    /* Make the target cursor */
    cursor = XCreateFontCursor(dpy, XC_crosshair);

    /* Grab the pointer using target cursor, letting it room all over */
    status = XGrabPointer(dpy, root, False,
            ButtonPressMask|ButtonReleaseMask, GrabModeSync,
            GrabModeAsync, root, cursor, CurrentTime);
    if (status != GrabSuccess) {
        fputs("ERROR: Cannot grab mouse.\n", stderr);
        return 0;
    }

    /* Let the user select a window... */
    while ((target_win == None) || (buttons != 0)) {
        /* allow one more event */
        XAllowEvents(dpy, SyncPointer, CurrentTime);
        XWindowEvent(dpy, root, ButtonPressMask|ButtonReleaseMask, &event);
        switch (event.type) {
            case ButtonPress:
                if (target_win == None) {
                    target_win = event.xbutton.subwindow; /* window selected */
                    if (target_win == None) target_win = root;
                }
                buttons++;
                break;
            case ButtonRelease:
                if (buttons > 0) /* there may have been some down before we started */
                    buttons--;
                break;
        }
    } 

    XUngrabPointer(dpy, CurrentTime);      /* Done with pointer */

    if (XGetGeometry (dpy, target_win, &root, &dummyi, &dummyi,
                &dummy, &dummy, &dummy, &dummy) && target_win != root) {
        target_win = XmuClientWindow (dpy, target_win);
    }
    
    return(target_win);
}/*}}}*/

static Window get_active_window(Display *disp) {/*{{{*/
    char *prop;
    unsigned long size;
    Window ret = (Window)0;
    
    prop = get_property(disp, DefaultRootWindow(disp), XA_WINDOW, 
                        "_NET_ACTIVE_WINDOW", &size);
    if (prop) {
        ret = *((Window*)prop);
        g_free(prop);
    }

    return(ret);
}/*}}}*/





int ReplaceStr(char *sSrc, char *sMatchStr, char *sReplaceStr)
{
   int  StringLen;
   char caNewString[1024];
   char *FindPos = strstr(sSrc, sMatchStr);
   if( (!FindPos) || (!sMatchStr) )
      return -1;
   while( FindPos )
   {
      memset(caNewString, 0, sizeof(caNewString));
      StringLen = FindPos - sSrc;
      strncpy(caNewString, sSrc, StringLen);
      strcat(caNewString, sReplaceStr);
      strcat(caNewString, FindPos + strlen(sMatchStr));
      strcpy(sSrc, caNewString);
      FindPos = strstr(sSrc, sMatchStr);
   }

   return 0;
}
void showwin3(int screenX,int screenY,int screenWidth)
{
  char text[1024];  
  int text_w,text_h;
  char aa[1024];
//  buffer3 = imlib_create_image(1000, 30);  
//  font3 = imlib_load_font("Vera/11");
  imlib_context_set_font(font3);
  imlib_context_set_color(0, 0, 0, 255);
  time_t now_time;
  now_time=time(0);
  if (show_windows>0)
  {
    if (i3==1)
    {
      strftime(text, sizeof(text), "%H:%M 窗",localtime(&now_time) );
      i3=0;
    } else {
      strftime(text, sizeof(text), "  %H %M  ",localtime(&now_time) );
      i3=1;
      strftime(aa, sizeof(aa), "%H:%M",localtime(&now_time) );
      if ((open_close[1]==1) and (strcmp(aa,Alarm1[1])==0 ))
        sprintf(text,"%s",say_text[1]);
      if ((open_close[2]==1) and (strcmp(aa,Alarm1[2])==0 ))
        sprintf(text,"%s",say_text[2]);
      if ((open_close[3]==1) and (strcmp(aa,Alarm1[3])==0 ))
        sprintf(text,"%s",say_text[3]);
    }
    show_windows=show_windows-1;
  } else {
    if (i3==1)
    {
      strftime(text, sizeof(text), "  %H:%M  ",localtime(&now_time) );
      i3=0;
    } else {
      strftime(text, sizeof(text), "  %H %M  ",localtime(&now_time) );
      i3=1;
      strftime(aa, sizeof(aa), "%H:%M",localtime(&now_time) );
      if ((open_close[1]==1) and (strcmp(aa,Alarm1[1])==0 ))
        sprintf(text,"%s",say_text[1]);
      if ((open_close[2]==1) and (strcmp(aa,Alarm1[2])==0 ))
        sprintf(text,"%s",say_text[2]);
      if ((open_close[3]==1) and (strcmp(aa,Alarm1[3])==0 ))
        sprintf(text,"%s",say_text[3]);
    }
  }    
//char Alarm1[3][1024];
//char say_text[3][1024];
//int open_close[3];
  
  imlib_get_text_size(text, &text_w, &text_h);
//  win3=XCreateWindow(disp,DefaultRootWindow(disp),screenX+screenWidth-20,screenY,text_w+10,text_h+4,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
  XRaiseWindow(disp,win3);
  XMapWindow(disp, win3);
  imlib_context_set_drawable(win3); 
//  imlib_context_set_image(buffer);
     /* draw the range */
  imlib_context_set_image(buffer3);
  imlib_image_fill_color_range_rectangle(0,0, text_w*4, text_h*2,-45.0);
     /* free it */
      //     imlib_free_color_range();
  imlib_context_set_image(buffer3);
  imlib_context_set_drawable(win3); 
  imlib_render_image_on_drawable(0, 0); 
//  imlib_context_set_image(buffer3);
  imlib_context_set_font(font3);
  imlib_context_set_color(0, 0, 0, 255);
  imlib_text_draw(5,2,text);
//  imlib_free_font();
  /* set the buffer image as our current image */
  imlib_context_set_image(buffer3);
  imlib_render_image_on_drawable(0, 0); 
  imlib_context_set_image(buffer3);
//  imlib_free_image();
}

void init_window(int win_id)
{

  unsigned long action;
  gchar *tmp_prop2, *tmp2;
  gchar *tmp_prop1, *tmp1;
  char *p1="maximized_vert", *p2="maximized_horz";
  Atom prop1 = 0;
  Atom prop2 = 0;
  action = _NET_WM_STATE_REMOVE;
  tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
  p_verbose("State 2: %s\n", tmp_prop2); 
  prop2 = XInternAtom(disp, tmp_prop2, False);
  tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
  p_verbose("State 1: %s\n", tmp_prop1); 
  prop1 = XInternAtom(disp, tmp_prop1, False);
  client_msg(disp, win_id, "_NET_WM_STATE", 
    action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
  p1="fullscreen";
  p2="above";
  prop1 = 0;
  prop2 = 0;
  action = _NET_WM_STATE_REMOVE;
  tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
  p_verbose("State 2: %s\n", tmp_prop2); 
  prop2 = XInternAtom(disp, tmp_prop2, False);
  tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
  p_verbose("State 1: %s\n", tmp_prop1); 
  prop1 = XInternAtom(disp, tmp_prop1, False);
  client_msg(disp, win_id, "_NET_WM_STATE", 
      action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
}

int main(int argc, char **argv)
{
  int                 w, h, x, y;
  Imlib_Image         im_bg = NULL;
  XEvent              ev;
  const char         *display_name = getenv("DISPLAY");
  Imlib_Image         buffer;
  Imlib_Image         back;
  Imlib_Image         bigback;
  Imlib_Font          font;
  char                text[1024];
  char                *skip;
  Imlib_Color_Range   range;
  int  text_w, text_h;
  if (display_name == NULL)
    display_name = ":0";
  disp = XOpenDisplay(display_name);
  if (disp == NULL)
  {
    fprintf(stderr, "Can't open display %s\n", display_name);
    return 1;
  }
  Imlib_Image        temp, temp2;

  int screen=DefaultScreen(disp);
  int screenWidth=0;
  screenWidth=XDisplayWidth(disp,screen);
  screenWidth=64;
  int screenHeight;
  screenHeight=64;
  int screenX=10;
  int screenY=10;
  char picname[1024];
  int find_win_time=15;
  int xl=0;
  int yl=0;
  int store=0;
  int s_g;
  int last_max_win_id=0;
  char submenue[1000];
  char ch2[1024];
  int n=0;
  int w_chg=0;
  int act_win=0;
  int Tiling_mode=0;
  char title_win_xy[33][50];
  char usermenufile[1024];
  char home[1024];
  sprintf(home,"%s",getenv("HOME"));
  if ( home == "" )
  {
    printf("fatal error: no /home/xxx found!\n");
    return 1;
  }
//----arguments x y width height lower/raise(0/1) picture hidemode
  if ( argc != 5 )
  {
    printf("usage: icon-clock x y image skip\n");
    return 1;
  }
 // printf("ok\n");
  sscanf(argv[1], "%d", &screenX);
  sscanf(argv[2], "%d", &screenY);
  sscanf(argv[3], "%s", &picname);
  skip=argv[4];
  screenWidth=2;
  screenHeight=2;
  vis = DefaultVisual(disp, DefaultScreen(disp));
  depth = DefaultDepth(disp, DefaultScreen(disp));
  cm = DefaultColormap(disp, DefaultScreen(disp));
        // text
  range = imlib_create_color_range();
  imlib_context_set_color_range(range);
  imlib_context_set_color(255, 255, 255, 255);
  imlib_add_color_to_color_range(0);
  /* add an orange color, semi-transparent 10 units from the first */
  imlib_context_set_color(255, 200, 10, 255);
  imlib_add_color_to_color_range(10);
  /* add black, fully transparent at the end 20 units away */
  imlib_context_set_color(70, 0, 0, 255);
  imlib_add_color_to_color_range(20);

  attr.override_redirect=True;
 //win=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,screenWidth,screenHeight,0,CopyFromParent,InputOutput,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask|CWBorderPixel|CWSaveUnder|CWColormap|CWBackPixel,&attr);
  win=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,screenWidth,screenHeight,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
//   win =  XCreateSimpleWindow(disp, DefaultRootWindow(disp), 0, 0, 100, 100, 0, 0, 0);
//  XSelectInput(disp, win, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
  XMapWindow(disp, win);

  XRaiseWindow(disp,win);

   /**
    * Start rendering
    */

  imlib_context_set_display(disp);
  imlib_context_set_visual(vis);
  imlib_context_set_colormap(cm);
  imlib_context_set_drawable(win);
  imlib_context_set_dither(1);
  imlib_context_set_blend(0);
  imlib_context_set_color_modifier(NULL);

//--
  w=screenWidth;
  h=screenHeight;
  back = imlib_load_image("../pics/background.jpg");
  imlib_context_set_image(back);
  buffer = imlib_create_cropped_scaled_image(0, 0,imlib_image_get_width() ,imlib_image_get_height() , w , h);
  im_bg = imlib_load_image(picname);
  XMapWindow(disp, win);
  imlib_context_set_image(im_bg);

  int is=imlib_image_get_width();
  int ih=imlib_image_get_height();
  int d1=screenWidth-is;
  d1=d1/2;
  int d2=screenHeight-ih;
  d2=d2/2;

  imlib_context_set_image(im_bg);
  imlib_context_set_blend(1);

  imlib_context_set_image(back);
  imlib_render_image_on_drawable(0, 0);
  imlib_context_set_image(im_bg);
  imlib_render_image_on_drawable_at_size(d1-1, d2-1,is+2,ih+2);
  bigback=imlib_create_image_from_drawable( 0,0,0,w,h,1);

  imlib_context_set_image(back);
  imlib_render_image_on_drawable(0, 0);
  imlib_context_set_image(im_bg);

  imlib_render_image_on_drawable(d1, d2);
  back=imlib_create_image_from_drawable( 0,0,0,w,h,1);

  XResizeWindow(disp, win, w, h);
  XSync(disp, False);
  
  x = -9999;
  y = -9999;
  x = -screenWidth/2;
  y = -screenHeight/2;
  int i=1;
  i3=1;
  Window cur_win=0;
  Window              cur_win_id;
  int xfd = ConnectionNumber(disp);
  fd_set rfds;
  long ticks;
            MWMHints mwmhints;
            Atom prop;

  time_t now_time;
  timeval now, tm,LastTime,LastTime2;
  now_time=time(0);

  list_windows(disp,skip);
  
  last_max_win_id=max_win_id;
  gettimeofday(&LastTime, 0);
  gettimeofday(&LastTime2, 0);


  buffer3 = imlib_create_image(1000, 30);  
  font3 = imlib_load_font("Vera/11");
  imlib_context_set_font(font3);
  imlib_context_set_color(0, 0, 0, 255);
  if (i3==1)
  {
    strftime(text, sizeof(text), "%H:%M",localtime(&now_time) );
    i3=0;
  } else {
    strftime(text, sizeof(text), "%H %M",localtime(&now_time) );
    i3=1;
  }
  imlib_get_text_size(text, &text_w, &text_h);
  win3=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,text_w+30,text_h+4,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
  XSelectInput(disp, win3, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
//  imlib_free_font();

  Tiling_mode=0;
  unsigned long action;
  gchar *tmp_prop2, *tmp2;
  gchar *tmp_prop1, *tmp1;

  char command[1024]=" ";
  FILE *freeNum;

  char rcfile[10]="clock.rc";
  sprintf(usermenufile,"%s/.icon-DE/%s",home,rcfile);
  freeNum=fopen(usermenufile,"r");
  if ( freeNum==NULL)
  { 
    printf("error on open %s\n",usermenufile); 
    exit(1); 
  }
  char ch;
  char buffer_rc[1024];
  int m=0;

  while ( ! feof(freeNum) )
  {
    fgets(buffer_rc,1024,freeNum);
    for (n=0;n<1024;n++)
      if (buffer_rc[n]=='\n') buffer_rc[n]='\0';
    printf("%s\n",buffer_rc); 
    sprintf(command,"");
    if (strcmp(buffer_rc,"")!=0 )
    {
      sprintf(ch2,"%c",buffer_rc[0]);
      if (strcmp(ch2,"#")!=0 ) 
      {
        sprintf(ch2,"%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6]);
        if (strcmp(ch2,"Alarm1:")==0 )
        {
          for (n=0;n<1024-7;n++)
          {
             buffer_rc[n]=buffer_rc[n+7];
          } 
          for (n=1016;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          int m=0;
          ch='a';
          sprintf(ch2,"");
          while ( buffer_rc[m] != ' ' )
          {
            sprintf(ch2,"%s%c",ch2,buffer_rc[m]);
            m=m+1;
          }
          for (n=0;n<1024-m;n++)
          {
             buffer_rc[n]=buffer_rc[n+m+1];
          } 
          for (n=1024-m;n<1024;n++)
          {
             buffer_rc[n]='\0';
          } 
          sprintf(Alarm1[1],"%s",ch2);
          m=0;
          ch='a';
          sprintf(ch2,"");
          while ( buffer_rc[m] != ' ' )
          {
            sprintf(ch2,"%s%c",ch2,buffer_rc[m]);
            m=m+1;
          }
          for (n=0;n<1024-m;n++)
          {
             buffer_rc[n]=buffer_rc[n+m+1];
          } 
          for (n=1024-m;n<1024;n++)
          {
             buffer_rc[n]='\0';
          } 
          sprintf(say_text[1],"%s",ch2);
          open_close[1] = atoi(buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6]);
        if (strcmp(ch2,"Alarm2:")==0 )
        {
          for (n=0;n<1024-7;n++)
          {
             buffer_rc[n]=buffer_rc[n+7];
          } 
          for (n=1016;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          int m=0;
          ch='a';
          sprintf(ch2,"");
          while ( buffer_rc[m] != ' ' )
          {
            sprintf(ch2,"%s%c",ch2,buffer_rc[m]);
            m=m+1;
          }
          for (n=0;n<1024-m;n++)
          {
             buffer_rc[n]=buffer_rc[n+m+1];
          } 
          for (n=1024-m;n<1024;n++)
          {
             buffer_rc[n]='\0';
          } 
          sprintf(Alarm1[2],"%s",ch2);
          m=0;
          ch='a';
          sprintf(ch2,"");
          while ( buffer_rc[m] != ' ' )
          {
            sprintf(ch2,"%s%c",ch2,buffer_rc[m]);
            m=m+1;
          }
          for (n=0;n<1024-m;n++)
          {
             buffer_rc[n]=buffer_rc[n+m+1];
          } 
          for (n=1024-m;n<1024;n++)
          {
             buffer_rc[n]='\0';
          } 
          sprintf(say_text[2],"%s",ch2);
          open_close[2] = atoi(buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6]);
        if (strcmp(ch2,"Alarm2:")==0 )
        {
          for (n=0;n<1024-7;n++)
          {
             buffer_rc[n]=buffer_rc[n+7];
          } 
          for (n=1016;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          int m=0;
          ch='a';
          sprintf(ch2,"");
          while ( buffer_rc[m] != ' ' )
          {
            sprintf(ch2,"%s%c",ch2,buffer_rc[m]);
            m=m+1;
          }
          for (n=0;n<1024-m;n++)
          {
             buffer_rc[n]=buffer_rc[n+m+1];
          } 
          for (n=1024-m;n<1024;n++)
          {
             buffer_rc[n]='\0';
          } 
          sprintf(Alarm1[3],"%s",ch2);
          m=0;
          ch='a';
          sprintf(ch2,"");
          while ( buffer_rc[m] != ' ' )
          {
            sprintf(ch2,"%s%c",ch2,buffer_rc[m]);
            m=m+1;
          }
          for (n=0;n<1024-m;n++)
          {
             buffer_rc[n]=buffer_rc[n+m+1];
          } 
          for (n=1024-m;n<1024;n++)
          {
             buffer_rc[n]='\0';
          } 
          sprintf(say_text[3],"%s",ch2);
          open_close[3] = atoi(buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window02_1_1:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[1],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window02_1_2:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[2],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window02_2_1:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[3],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window02_2_2:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[4],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window02_3_1:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[5],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window02_3_2:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[6],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window03_1_1:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[11],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window03_1_2:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[12],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window03_1_3:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[13],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window03_2_1:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[14],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window03_2_2:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[15],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window03_2_3:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[16],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window03_3_1:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[17],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window03_3_2:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[18],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window03_3_3:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[19],"%s",buffer_rc);
        }
        
        
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window04_1_1:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[21],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window04_1_2:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[22],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window04_1_3:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[23],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window04_1_4:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[24],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window04_2_1:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[25],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window04_2_2:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[26],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window04_2_3:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[27],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window04_2_4:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[28],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window04_3_1:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[29],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window04_3_2:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[30],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window04_3_3:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[31],"%s",buffer_rc);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15],buffer_rc[16],buffer_rc[17],buffer_rc[18],buffer_rc[19]);
        if (strcmp(ch2,"Tiling_window04_3_4:")==0 )
        {
          for (n=0;n<1024-20;n++)
          {
             buffer_rc[n]=buffer_rc[n+20];
          } 
          for (n=1003;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(title_win_xy[32],"%s",buffer_rc);
        }
      }
    }    
  }
  fclose(freeNum);



  while (1)
  {
    w_chg=1;
    if (XPending(disp))
    {
      XNextEvent(disp, &ev);
      switch (ev.type)
      {
      case Expose:
        break;
      case MotionNotify:
        x = ev.xmotion.x;
        y = ev.xmotion.y;
      default:
        break;
      case EnterNotify:		
        break;
      case LeaveNotify:		
        break;
      case ButtonPress:				
        if(ev.xbutton.button==1)
        {
          if (list_windows(disp,skip)!=EXIT_FAILURE)
          {
            memset(&mwmhints, 0, sizeof(mwmhints));
            prop = XInternAtom(disp, "_MOTIF_WM_HINTS", False);
            mwmhints.flags = MWM_HINTS_DECORATIONS;
            mwmhints.decorations = 0;
            for (i=0;i<win_count;i++)
            {
              if (win_pid_list[i]!=0)
              {
                XChangeProperty(disp, win_pid_list[i], prop, prop, 32, PropModeReplace,
                      (unsigned char *) &mwmhints,
                      PROP_MWM_HINTS_ELEMENTS);
              }
            }
            sprintf(submenue,"./icon-wharf BORD 1");
            system(submenue);
          }  
          break;
        }
        if(ev.xbutton.button==2)
        {
          if (clock_move==0)
          {
            XMoveWindow(disp, win, screenX, screenY+50);
            XMoveWindow(disp, win3, screenX, screenY+50);
            clock_move=1;
          } else {
            XMoveWindow(disp, win, screenX, screenY);
            XMoveWindow(disp, win3, screenX, screenY);
            clock_move=0;
          }
          break;
        }
        if(ev.xbutton.button==3)
        {
          if (list_windows(disp,skip)!=EXIT_FAILURE)
          {
            memset(&mwmhints, 0, sizeof(mwmhints));
            prop = XInternAtom(disp, "_MOTIF_WM_HINTS", false);
            mwmhints.flags=MWM_HINTS_FUNCTIONS | MWM_HINTS_DECORATIONS;
            mwmhints.functions|=( MWM_FUNC_MOVE | MWM_FUNC_CLOSE | MWM_FUNC_MINIMIZE | MWM_FUNC_MAXIMIZE | MWM_FUNC_RESIZE );
            mwmhints.decorations|=MWM_DECOR_ALL;
            for (i=0;i<win_count;i++)
            {
              if (win_pid_list[i]!=0)
              {
                XChangeProperty(disp, win_pid_list[i], prop, prop, 32, PropModeReplace,
                      (unsigned char *) &mwmhints,
                      PROP_MWM_HINTS_ELEMENTS); 
              }
            }
            sprintf(submenue,"./icon-wharf BORD 0 ");
            system(submenue);
          }  
          break;
        }
        if(ev.xbutton.button==4)
        {
          list_windows(disp,skip);
          cur_win=get_active_window(disp);
          int is_5=0;
          int is_6=0;
          printf("%d\n",win_count);
          if (win_count==2)
          {
            if (Tiling_mode==0)
            {
              for (i=0;i<win_count;i++)
              {
                init_window(win_pid_list[i]);
                if (cur_win!=NULL)
                {
                  if (win_pid_list[i]==cur_win) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[1]);
                  else
                    window_move_resize(disp,win_pid_list[i],title_win_xy[2]);
                  printf("%s %d \n",title_win_xy[0],win_pid_list[i]);
                } else { 
                  if (i==0) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[1]);
                  else
                    window_move_resize(disp,win_pid_list[i],title_win_xy[2]);
                }      
                Tiling_mode=1;
              }  
            } else if (Tiling_mode==1) {
              for (i=0;i<win_count;i++)
              {
                init_window(win_pid_list[i]);
                if (cur_win!=NULL)
                {
                  if (win_pid_list[i]==cur_win) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[3]);
                  else
                    window_move_resize(disp,win_pid_list[i],title_win_xy[4]);
                  printf("%s %d \n",title_win_xy[0],win_pid_list[i]);
                } else { 
                  if (i==0) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[3]);
                  else
                    window_move_resize(disp,win_pid_list[i],title_win_xy[4]);
                }      
              }    
              Tiling_mode=2;
            } else if (Tiling_mode==2)  {
              for (i=0;i<win_count;i++)
              {
                init_window(win_pid_list[i]);
                if (cur_win!=NULL)
                {
                  if (win_pid_list[i]==cur_win) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[5]);
                  else
                    window_move_resize(disp,win_pid_list[i],title_win_xy[6]);
                  printf("%s %d \n",title_win_xy[0],win_pid_list[i]);
                } else { 
                  if (i==0) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[5]);
                  else
                    window_move_resize(disp,win_pid_list[i],title_win_xy[6]);
                }      
              }    
              Tiling_mode=3;
            } else if (Tiling_mode==3) {
              if (cur_win!=NULL)
              {
                char *p1="fullscreen", *p2="above";
                Atom prop1 = 0;
                Atom prop2 = 0;
                action = _NET_WM_STATE_ADD;
                tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
                p_verbose("State 2: %s\n", tmp_prop2); 
                prop2 = XInternAtom(disp, tmp_prop2, False);
                tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                p_verbose("State 1: %s\n", tmp_prop1); 
                prop1 = XInternAtom(disp, tmp_prop1, False);
                client_msg(disp, cur_win, "_NET_WM_STATE", 
                    action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
              }	  
              Tiling_mode=0;
            }
          } 
          if (win_count==3)
          {
            if (Tiling_mode==0)
            {
              for (i=0;i<win_count;i++)
              {
                init_window(win_pid_list[i]);
                if (cur_win!=NULL)
                {
                    if (win_pid_list[i]==cur_win) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[11]);
                    else
                    {
                      if (is_5==0)
                      {
                        window_move_resize(disp,win_pid_list[i],title_win_xy[12]);
                        is_5=1;
                      } else
                        window_move_resize(disp,win_pid_list[i],title_win_xy[13]);
                    }  
                } else { 
                    if (i==0) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[11]);
                    if (i==1) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[12]);
                    if (i==2) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[13]);
                }      
              }
              Tiling_mode=1;
            } else if (Tiling_mode==1) {
              for (i=0;i<win_count;i++)
              {
                init_window(win_pid_list[i]);
                if (cur_win!=NULL)
                {
                  if (win_pid_list[i]==cur_win) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[14]);
                  else
                  {
                    if (is_5==0)
                    {
                      window_move_resize(disp,win_pid_list[i],title_win_xy[15]);
                      is_5=1;
                    } else
                      window_move_resize(disp,win_pid_list[i],title_win_xy[16]);
                  }  
                } else { 
                  if (i==0) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[14]);
                  if (i==1) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[15]);
                  if (i==2) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[16]);
                } 
              }  
              Tiling_mode=2;
            } else if (Tiling_mode==2) {
              for (i=0;i<win_count;i++)
              {
                init_window(win_pid_list[i]);
                if (cur_win!=NULL)
                {
                  if (win_pid_list[i]==cur_win) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[17]);
                  else
                  {
                    if (is_5==0)
                    {
                      window_move_resize(disp,win_pid_list[i],title_win_xy[18]);
                      is_5=1;
                    } else
                      window_move_resize(disp,win_pid_list[i],title_win_xy[19]);
                  }  
                } else { 
                  if (i==0) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[17]);
                  if (i==1) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[18]);
                  if (i==2) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[19]);
                } 
              }  
              Tiling_mode=3;
            } else {
              if (cur_win!=NULL) {
                char *p1="fullscreen", *p2="above";
                Atom prop1 = 0;
                Atom prop2 = 0;
                action = _NET_WM_STATE_ADD;
                tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
                p_verbose("State 2: %s\n", tmp_prop2); 
                prop2 = XInternAtom(disp, tmp_prop2, False);
                tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                p_verbose("State 1: %s\n", tmp_prop1); 
                prop1 = XInternAtom(disp, tmp_prop1, False);
                client_msg(disp, cur_win, "_NET_WM_STATE", 
                  action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
              }	  
              Tiling_mode=0;
            }
            break;
          }  
          if (win_count==4)
          {
            if (Tiling_mode==0)
            {
              for (i=0;i<win_count;i++)
              {
                init_window(win_pid_list[i]);
                if (cur_win!=NULL)
                {
                    if (win_pid_list[i]==cur_win) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[21]);
                    else
                    {
                      if (is_5==0)
                      {
                        window_move_resize(disp,win_pid_list[i],title_win_xy[22]);
                        is_5=1;
                        is_6=0;
                      } else if (is_6==0) {
                        window_move_resize(disp,win_pid_list[i],title_win_xy[23]);
                        is_6=1;
                      } else {
                        window_move_resize(disp,win_pid_list[i],title_win_xy[24]);
                        is_5=0;
                        is_6=0;
				      }
                    }  
                } else { 
                    if (i==0) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[21]);
                    if (i==1) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[22]);
                    if (i==2) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[23]);
                    if (i==2) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[24]);
                }      
              }
              Tiling_mode=1;
            } else if (Tiling_mode==1) {
              for (i=0;i<win_count;i++)
              {
                init_window(win_pid_list[i]);
                if (cur_win!=NULL)
                {
                    if (win_pid_list[i]==cur_win) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[25]);
                    else
                    {
                      if (is_5==0)
                      {
                        window_move_resize(disp,win_pid_list[i],title_win_xy[26]);
                        is_5=1;
                        is_6=0;
                      } else if (is_6==0) {
                        window_move_resize(disp,win_pid_list[i],title_win_xy[27]);
                        is_6=1;
                      } else {
                        window_move_resize(disp,win_pid_list[i],title_win_xy[28]);
                        is_5=0;
                        is_6=0;
				      }
                    }  
                } else { 
                    if (i==0) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[25]);
                    if (i==1) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[26]);
                    if (i==2) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[27]);
                    if (i==2) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[28]);
                }      
              }
              Tiling_mode=2;
            } else if (Tiling_mode==2) {
              for (i=0;i<win_count;i++)
              {
                init_window(win_pid_list[i]);
                if (cur_win!=NULL)
                {
                    if (win_pid_list[i]==cur_win) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[29]);
                    else
                    {
                      if (is_5==0)
                      {
                        window_move_resize(disp,win_pid_list[i],title_win_xy[30]);
                        is_5=1;
                        is_6=0;
                      } else if (is_6==0) {
                        window_move_resize(disp,win_pid_list[i],title_win_xy[31]);
                        is_6=1;
                      } else {
                        window_move_resize(disp,win_pid_list[i],title_win_xy[32]);
                        is_5=0;
                        is_6=0;
				      }
                    }  
                } else { 
                    if (i==0) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[29]);
                    if (i==1) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[30]);
                    if (i==2) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[31]);
                    if (i==2) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[32]);
                }      
              }
              Tiling_mode=3;
            } else {
              if (cur_win!=NULL) {
                char *p1="fullscreen", *p2="above";
                Atom prop1 = 0;
                Atom prop2 = 0;
                action = _NET_WM_STATE_ADD;
                tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
                p_verbose("State 2: %s\n", tmp_prop2); 
                prop2 = XInternAtom(disp, tmp_prop2, False);
                tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                p_verbose("State 1: %s\n", tmp_prop1); 
                prop1 = XInternAtom(disp, tmp_prop1, False);
                client_msg(disp, cur_win, "_NET_WM_STATE", 
                  action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
              }	  
              Tiling_mode=0;
            }
            break;
          }  
        }
        if(ev.xbutton.button==5)
        {
          list_windows(disp,skip);
          cur_win=get_active_window(disp);
          int is_5=0;
          int is_6=0;
          if (win_count==2)
          {
            if (Tiling_mode==0)
            {
              for (i=0;i<win_count;i++)
              {
                init_window(win_pid_list[i]);
                if (cur_win!=NULL)
                {
                  if (win_pid_list[i]==cur_win) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[1]);
                  else
                    window_move_resize(disp,win_pid_list[i],title_win_xy[2]);
                  printf("%s %d \n",title_win_xy[0],win_pid_list[i]);
                } else { 
                  if (i==0) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[1]);
                  else
                    window_move_resize(disp,win_pid_list[i],title_win_xy[2]);
                }      
                Tiling_mode=1;
              }  
            } else if (Tiling_mode==1) {
              for (i=0;i<win_count;i++)
              {
                init_window(win_pid_list[i]);
                if (cur_win!=NULL)
                {
                  if (win_pid_list[i]==cur_win) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[3]);
                  else
                    window_move_resize(disp,win_pid_list[i],title_win_xy[4]);
                  printf("%s %d \n",title_win_xy[0],win_pid_list[i]);
                } else { 
                  if (i==0) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[3]);
                  else
                    window_move_resize(disp,win_pid_list[i],title_win_xy[4]);
                }      
              }    
              Tiling_mode=2;
            } else if (Tiling_mode==2)  {
              for (i=0;i<win_count;i++)
              {
                init_window(win_pid_list[i]);
                if (cur_win!=NULL)
                {
                  if (win_pid_list[i]==cur_win) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[5]);
                  else
                    window_move_resize(disp,win_pid_list[i],title_win_xy[6]);
                  printf("%s %d \n",title_win_xy[0],win_pid_list[i]);
                } else { 
                  if (i==0) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[5]);
                  else
                    window_move_resize(disp,win_pid_list[i],title_win_xy[6]);
                }      
              }    
              Tiling_mode=3;
            } else if (Tiling_mode==3) {
              if (cur_win!=NULL)
              {
                char *p1="fullscreen", *p2="above";
                Atom prop1 = 0;
                Atom prop2 = 0;
                action = _NET_WM_STATE_ADD;
                tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
                p_verbose("State 2: %s\n", tmp_prop2); 
                prop2 = XInternAtom(disp, tmp_prop2, False);
                tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                p_verbose("State 1: %s\n", tmp_prop1); 
                prop1 = XInternAtom(disp, tmp_prop1, False);
                client_msg(disp, cur_win, "_NET_WM_STATE", 
                    action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
              }	  
              Tiling_mode=0;
            }
          } 
          if (win_count==3)
          {
            if (Tiling_mode==0)
            {
              for (i=0;i<win_count;i++)
              {
                init_window(win_pid_list[i]);
                if (cur_win!=NULL)
                {
                    if (win_pid_list[i]==cur_win) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[11]);
                    else
                    {
                      if (is_5==0)
                      {
                        window_move_resize(disp,win_pid_list[i],title_win_xy[12]);
                        is_5=1;
                      } else
                        window_move_resize(disp,win_pid_list[i],title_win_xy[13]);
                    }  
                } else { 
                    if (i==0) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[11]);
                    if (i==1) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[12]);
                    if (i==2) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[13]);
                }      
              }
              Tiling_mode=1;
            } else if (Tiling_mode==1) {
              for (i=0;i<win_count;i++)
              {
                init_window(win_pid_list[i]);
                if (cur_win!=NULL)
                {
                  if (win_pid_list[i]==cur_win) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[14]);
                  else
                  {
                    if (is_5==0)
                    {
                      window_move_resize(disp,win_pid_list[i],title_win_xy[15]);
                      is_5=1;
                    } else
                      window_move_resize(disp,win_pid_list[i],title_win_xy[16]);
                  }  
                } else { 
                  if (i==0) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[14]);
                  if (i==1) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[15]);
                  if (i==2) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[16]);
                } 
              }  
              Tiling_mode=2;
            } else if (Tiling_mode==2) {
              for (i=0;i<win_count;i++)
              {
                init_window(win_pid_list[i]);
                if (cur_win!=NULL)
                {
                  if (win_pid_list[i]==cur_win) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[17]);
                  else
                  {
                    if (is_5==0)
                    {
                      window_move_resize(disp,win_pid_list[i],title_win_xy[18]);
                      is_5=1;
                    } else
                      window_move_resize(disp,win_pid_list[i],title_win_xy[19]);
                  }  
                } else { 
                  if (i==0) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[17]);
                  if (i==1) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[18]);
                  if (i==2) 
                    window_move_resize(disp,win_pid_list[i],title_win_xy[19]);
                } 
              }  
              Tiling_mode=3;
            } else {
              if (cur_win!=NULL) {
                char *p1="fullscreen", *p2="above";
                Atom prop1 = 0;
                Atom prop2 = 0;
                action = _NET_WM_STATE_ADD;
                tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
                p_verbose("State 2: %s\n", tmp_prop2); 
                prop2 = XInternAtom(disp, tmp_prop2, False);
                tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                p_verbose("State 1: %s\n", tmp_prop1); 
                prop1 = XInternAtom(disp, tmp_prop1, False);
                client_msg(disp, cur_win, "_NET_WM_STATE", 
                  action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
              }	  
              Tiling_mode=0;
            }
          }  
          if (win_count==4)
          {
            if (Tiling_mode==0)
            {
              for (i=0;i<win_count;i++)
              {
                init_window(win_pid_list[i]);
                if (cur_win!=NULL)
                {
                    if (win_pid_list[i]==cur_win) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[21]);
                    else
                    {
                      if (is_5==0)
                      {
                        window_move_resize(disp,win_pid_list[i],title_win_xy[22]);
                        is_5=1;
                        is_6=0;
                      } else if (is_6==0) {
                        window_move_resize(disp,win_pid_list[i],title_win_xy[23]);
                        is_6=1;
                      } else {
                        window_move_resize(disp,win_pid_list[i],title_win_xy[24]);
                        is_5=0;
                        is_6=0;
				      }
                    }  
                } else { 
                    if (i==0) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[21]);
                    if (i==1) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[22]);
                    if (i==2) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[23]);
                    if (i==2) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[24]);
                }      
              }
              Tiling_mode=1;
            } else if (Tiling_mode==1) {
              for (i=0;i<win_count;i++)
              {
                init_window(win_pid_list[i]);
                if (cur_win!=NULL)
                {
                    if (win_pid_list[i]==cur_win) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[25]);
                    else
                    {
                      if (is_5==0)
                      {
                        window_move_resize(disp,win_pid_list[i],title_win_xy[26]);
                        is_5=1;
                        is_6=0;
                      } else if (is_6==0) {
                        window_move_resize(disp,win_pid_list[i],title_win_xy[27]);
                        is_6=1;
                      } else {
                        window_move_resize(disp,win_pid_list[i],title_win_xy[28]);
                        is_5=0;
                        is_6=0;
				      }
                    }  
                } else { 
                    if (i==0) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[25]);
                    if (i==1) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[26]);
                    if (i==2) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[27]);
                    if (i==2) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[28]);
                }      
              }
              Tiling_mode=2;
            } else if (Tiling_mode==2) {
              for (i=0;i<win_count;i++)
              {
                init_window(win_pid_list[i]);
                if (cur_win!=NULL)
                {
                    if (win_pid_list[i]==cur_win) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[29]);
                    else
                    {
                      if (is_5==0)
                      {
                        window_move_resize(disp,win_pid_list[i],title_win_xy[30]);
                        is_5=1;
                        is_6=0;
                      } else if (is_6==0) {
                        window_move_resize(disp,win_pid_list[i],title_win_xy[31]);
                        is_6=1;
                      } else {
                        window_move_resize(disp,win_pid_list[i],title_win_xy[32]);
                        is_5=0;
                        is_6=0;
				      }
                    }  
                } else { 
                    if (i==0) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[29]);
                    if (i==1) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[30]);
                    if (i==2) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[31]);
                    if (i==2) 
                      window_move_resize(disp,win_pid_list[i],title_win_xy[32]);
                }      
              }
              Tiling_mode=3;
            } else {
              if (cur_win!=NULL) {
                char *p1="fullscreen", *p2="above";
                Atom prop1 = 0;
                Atom prop2 = 0;
                action = _NET_WM_STATE_ADD;
                tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
                p_verbose("State 2: %s\n", tmp_prop2); 
                prop2 = XInternAtom(disp, tmp_prop2, False);
                tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                p_verbose("State 1: %s\n", tmp_prop1); 
                prop1 = XInternAtom(disp, tmp_prop1, False);
                client_msg(disp, cur_win, "_NET_WM_STATE", 
                  action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
              }	  
              Tiling_mode=0;
            }
          }  
          break;
        }  
      }
    } else {
        //display 是由 XopenDisplay 返回的 Display *
      w_chg=0;
      FD_ZERO(&rfds);
      FD_SET(xfd, &rfds);
      gettimeofday(&now, 0);
//LastTime 是 timeval 类型的变量,保存上次时间
//ticks 的单位是毫秒 millisecond
      ticks=(now.tv_sec-LastTime.tv_sec)*1000+(now.tv_usec-LastTime.tv_usec)/1000;
      if (ticks>=1000)
      {
        gettimeofday(&LastTime, 0);
        showwin3(screenX,screenY,screenWidth);
      }
      ticks=(now.tv_sec-LastTime2.tv_sec)*1000+(now.tv_usec-LastTime2.tv_usec)/1000;
      if (ticks>=1000*find_win_time)
      {
        if (list_windows(disp,skip)!=EXIT_FAILURE)
        {
          if (last_max_win_id!=max_win_id)
          {
            gettimeofday(&LastTime2, 0);
            show_windows=30;
            last_max_win_id=max_win_id;
          }  
        }
      }
//如果到期则调用有关函数
//select 等待 100 毫秒
      tm.tv_sec=0l;
      tm.tv_usec=100000l;
      select(xfd + 1, &rfds, 0, 0, &tm);
    } /* End else*/
    if (w_chg==1)
    {
          if(mytoggle == 1)
      {
        imlib_context_set_image(bigback);
        xl=x-24;
        yl=y-24;
      }else{
        imlib_context_set_image(back);
        xl=x-10;
        yl=y-10;
      }
    }
  }
  imlib_context_set_image(buffer3);
  imlib_context_set_drawable(win3); 
  imlib_render_image_on_drawable(0, 0); 
  imlib_context_set_image(buffer3);
  imlib_context_set_font(font3);
  imlib_context_set_color(0, 0, 0, 255);
  imlib_text_draw(5,2,text);
  imlib_free_font();
  /* set the buffer image as our current image */
  imlib_context_set_image(buffer3);
  imlib_render_image_on_drawable(0, 0); 
  imlib_context_set_image(buffer3);
  imlib_free_image();

  imlib_context_set_image(im_bg);
  imlib_context_set_drawable(win);
  temp = imlib_clone_image();
  imlib_context_set_image(temp);
  imlib_apply_filter
  ("bump_map_point(x=[],y=[],map=""blend.jpg);", &xl, &yl);
  imlib_context_set_image(back);
  imlib_render_image_on_drawable(0, 0);
  temp2 = im_bg;
  im_bg = temp;
  imlib_context_set_image(im_bg);
  imlib_context_set_blend(1);
  imlib_render_image_on_drawable(0, 0);
  im_bg = temp2;
  imlib_context_set_image(temp);
  imlib_free_image();
  return 0;
}

